package cli

import (
	"git.dragon-labs.de/alphyron/group_helper/models"
	tgbotapi "github.com/go-telegram-bot-api/telegram-bot-api"
)

type Command interface {
	GetUsage() string
	GetCommand() string
	GetDescription() string
	ExecuteCommand(*tgbotapi.BotAPI, *tgbotapi.Update, *models.Group) (bool, error)
	AllowChatType(*tgbotapi.Chat) bool
	AllowMember(*tgbotapi.ChatMember) bool
	AllowEveryMember() bool
}
