package logic

import (
	"git.dragon-labs.de/alphyron/group_helper/models"
)

type GroupHelperService interface {
	CreateGroup(*models.Group) (*models.Group, error)
	UpdateGroup(*models.Group) (*models.Group, error)

	GetGroupByID(int64) (*models.Group, error)
	GetGroupByDBID(uint64) (*models.Group, error)
	GetGroupDatabaseSize(*models.Group) (int, error)

	CreateUser(*models.User) (*models.User, error)
	GetUserByID(int64) (*models.User, error)

	UserJoinGroup(*models.User, *models.Group) (bool, error)
	UserLeaveGroup(*models.User, *models.Group) (bool, error)
	IsUserInGroup(*models.User, *models.Group) (bool, error)

	ListGroups() ([]*models.Group, error)
	ListGroupUsers(*models.Group) ([]*models.User, error)
	ListUsers() ([]*models.User, error)
}
